using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System;
using UnityEngine.Networking;
using System.Text;
using System.Security.Cryptography;
using System.Net;
using System.IO;
using Newtonsoft.Json.Linq;
using login;

/// <summary>
/// Http Request SDK 
/// </summary>
public class HttpTool : MonoSingleton<HttpTool>
{
    Dictionary<string, string> requestHeader = new Dictionary<string, string>();  //  header
    void Awake()
    {
        //http header 的内容
       // requestHeader.Add("Content-Type", "application/json");

    }

    //  public string Token
    // {
    // get { return token; }
    // }


    public Dictionary<string, string> RequestHeader
    {
        get { return requestHeader; }
    }

    public void PostTest(string methodName, string jsonString, Action<string> CallBack)
    {
        StartCoroutine(SendHttp(methodName, jsonString, CallBack));
    }
    public void Post(string methodName, string jsonString, Action<string> CallBack)
    {
        StartCoroutine(SendHttp(methodName, jsonString, CallBack));
    }

    /// <summary>
    ///  登录 
    /// </summary>
    /// <param name="methodName"></param>
    /// <param name="jsonString"></param>
    /// <param name="CallBack"></param>
    public void PostLogin(string methodName, string jsonString, Action<string> CallBack)
    {
        StartCoroutine(SendHttp(methodName, jsonString, CallBack));
    }

    public void initHead(string ContentType)
    {
        requestHeader.Clear();
        if (login.UserInfo.Instance.Token != "" && login.UserInfo.Instance.Token != null)
        {
            requestHeader.Add("x-token", login.UserInfo.Instance.Token);
            requestHeader.Add("authorization", login.UserInfo.Instance.Token);
        }
        requestHeader.Add("Content-Type", ContentType);
    }

    public IEnumerator SendHttp(string methodName, string jsonString, Action<string> CallBack, string ContentType = "application/json", bool isPost = true)
    {
        Debug.Log("Start Queue SendHttp " + methodName);
        string url;
        if (methodName.Contains("http"))
        {
            url = methodName;
        }
        else
        {
            url = HttpAction.Instance.baseurl + methodName;
        }
        Debug.Log("URL:" + url + " isPost  " + isPost);
        UnityWebRequest webRequest;
        if (!isPost)
        {
            webRequest = UnityWebRequest.Get(url);

        }
        else
        {
            webRequest = new UnityWebRequest(url, "POST");
        }
        initHead(ContentType);
        using (webRequest)
        {
            if (!isPost)
            {
                webRequest.downloadHandler = (DownloadHandler)new DownloadHandlerBuffer();
                foreach (var v in requestHeader)
                {
                    webRequest.SetRequestHeader(v.Key, v.Value);
                }
            }
            else
            {
                byte[] bodyRaw = Encoding.UTF8.GetBytes(jsonString);
                webRequest.uploadHandler = (UploadHandler)new UploadHandlerRaw(bodyRaw);
                webRequest.downloadHandler = (DownloadHandler)new DownloadHandlerBuffer();
            }

            foreach (var v in requestHeader)
            {
                webRequest.SetRequestHeader(v.Key, v.Value);
            }
            yield return webRequest.SendWebRequest();

            Debug.Log("CallBack==>" + webRequest.downloadHandler.text);
            if (webRequest.isHttpError || webRequest.isNetworkError)
            {
                string error = webRequest.downloadHandler.text;
                CallBack(error);
            }
            else
            {
                //Debug.Log(webRequest.downloadHandler.text);
                var mes = webRequest.downloadHandler.text;

                CallBack(mes);
            }
        }

    }
    public void HeadAddToken(string token)
    {
        requestHeader.Add("x-token", token);
    }

    public string GetMd5Hash(string strToEncrypt)
    {
        MD5CryptoServiceProvider md5 = new MD5CryptoServiceProvider();
        byte[] bytes = Encoding.ASCII.GetBytes(strToEncrypt);
        byte[] encoded = md5.ComputeHash(bytes);
        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < 10; i++)
        {
            sb.Append(encoded[i].ToString("x2"));
        }
        string password = sb.ToString();
        password = password.Substring(0, 10);
        return password;

    }
}
