using LitJson;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using SC.XR.Unity;
using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Text.RegularExpressions;
using UnityEngine;
using UnityEngine.UI;

public class LoginPanel : MonoBehaviour
{
    private SCInputField m_Account;
    private Button m_EmptyAccountBtn;
    private Text m_AccountErrorStr;
    private Transform m_AccountError;
    private string m_AccountStr;

    private SCInputField m_Password;
    private Button m_EmptyPwdBtn;
    //private Button m_LockPwdBtn;
    private bool m_Islock;
    private Text m_PwdErrorStr;
    private Transform m_PwdError;
    private string m_PasswordStr;

    private Button m_Logn;
    private Toggle m_RemenberPwd;
    private bool m_IsRemberPwd;

    private Button m_SNBtn;

    private Text m_SN;

   
   
    private void Awake()
    {

       
        m_Account = transform.Find("Account/SCInputField").GetComponent<SCInputField>();
        m_EmptyAccountBtn = transform.Find("Account/EmptyAccount").GetComponent<Button>();
        m_AccountErrorStr = transform.Find("Error/AccountError/Text").GetComponent<Text>();
        m_AccountError = transform.Find("Error/AccountError");

        m_Password = transform.Find("Password/SCInputField").GetComponent<SCInputField>();
        m_EmptyPwdBtn = transform.Find("Password/EmptyPassword").GetComponent<Button>();
        //m_LockPwdBtn = CacheTransform.Find("Password/Icon").GetComponent<Button>();
        //m_Islock = false;
        m_PwdErrorStr = transform.Find("Error/PasswordError/Text").GetComponent<Text>();
        m_PwdError = transform.Find("Error/PasswordError");

        m_Logn = transform.Find("LoginBtn").GetComponent<Button>();
        m_RemenberPwd = transform.Find("RememberPwd").GetComponent<Toggle>();
        m_RemenberPwd.isOn = false;
        m_IsRemberPwd = false;

        //m_SNBtn = CacheTransform.Find("SNLoginBtn").GetComponent<Button>();

       // m_SN = transform.Find("SNAndVersion/SN/Text").GetComponent<Text>();
        OnShow();
        AddUIListenEvent();
    }

    /// <summary>
    /// 添加UI的监听事件
    /// </summary>
    private void AddUIListenEvent()
    {
        m_Account.onEndEdit.AddListener(OnAccountEndEdit);
        m_EmptyAccountBtn.onClick.AddListener(OnclickEmptyAccount);

        m_Password.onEndEdit.AddListener(OnPasswordEndEdit);
        m_EmptyPwdBtn.onClick.AddListener(OnClickEmptyPwd);
        //m_LockPwdBtn.onClick.AddListener(OnclickLockPwd);
        //m_Password.contentType = SCInputField.ContentType.Standard;

        m_Logn.onClick.AddListener(OnClickLogin);
        m_RemenberPwd.onValueChanged.AddListener(OnRemPwdValueChange);

        //m_SNBtn.onClick.AddListener(OnClickSnBtn);

        OnClickLogin();
    }

    #region UI监听事件

    /// <summary>
    /// 账号输入完成
    /// </summary>
    /// <param name="str"></param>
    private void OnAccountEndEdit(string str)
    {
        m_AccountStr = "";
        if (string.IsNullOrWhiteSpace(str))
        {
            m_AccountError.gameObject.SetActive(true);
            m_AccountErrorStr.text = "请输入邮箱账号";
        }
        else
        {
            //邮箱名以数字或字母开头；邮箱名可由字母、数字、点号、减号、下划线组成；邮箱名（@前的字符）长度为3～18个字符；邮箱名不能以点号、减号或下划线结尾；不能出现连续两个或两个以上的点号、减号。  
            //string pattern = @"^[a-zA-Z0-9]((?<!(\.\.|--))[a-zA-Z0-9\._-]){1,16}[a-zA-Z0-9]@([0-9a-zA-Z][0-9a-zA-Z-]{0,62}\.)+([0-9a-zA-Z][0-9a-zA-Z-]{0,62})\.?|((25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(25[0-5]|2[0-4]\d|[01]?\d\d?)$";  
            string pattern = @"^([\w-\.]+)@([\w-\.]+)(\.[a-zA-Z0-9]+)$";

            if (Regex.IsMatch(str, pattern))
            {
                m_AccountStr = str;
                m_AccountErrorStr.text = "";
                m_AccountError.gameObject.SetActive(false);

            }
            else
            {
                m_AccountError.gameObject.SetActive(true);
                m_AccountErrorStr.text = "账号不合法";
            }
        }

        if (!string.IsNullOrWhiteSpace(m_AccountStr) && !string.IsNullOrWhiteSpace(m_PasswordStr))
        {
            m_Logn.interactable = true;
        }
    }
    /// <summary>
    /// 清理账号输入
    /// </summary>
    private void OnclickEmptyAccount()
    {
        m_AccountErrorStr.text = "账号不能为空";
        m_AccountError.gameObject.SetActive(true);
        m_AccountStr = "";
        m_Account.text = "";
        m_Logn.interactable = false;
    }
    /// <summary>
    /// 密码输入完成
    /// </summary>
    /// <param name="str"></param>
    private void OnPasswordEndEdit(string str)
    {
        m_PasswordStr = "";
        if (string.IsNullOrWhiteSpace(str))
        {
            m_PwdError.gameObject.SetActive(true);
            m_PwdErrorStr.text = "请输入密码";
        }
        else
        {
            Regex RegCHZN = new Regex("[\u4e00-\u9fa5]");
            if (RegCHZN.IsMatch(str))
            {
                m_PwdError.gameObject.SetActive(true);
                m_PwdErrorStr.text = "密码不合法";
                return;
            }

            //int n = 0;
            ////必须包含小写字母
            //string pattern1 = @"(?=.*[a-z])";
            ////必须包含大写字母
            //string pattern2 = @"(?=.*[A-Z])";
            ////必须包含数字
            //string pattern3 = @"(?=.*\d)";
            ////string pattern3 = @"(?=.*[0 - 9])";
            ////必须包含特殊符号
            //string pattern4 = @"(?=.*[ !""#$%&'()*+,-./:;<=>?@\[\]\^_`{|}~])";
            //string pattern4 = @"(?=([\x21-\x7e]+)[^a-zA-Z0-9])";
            //至少8个字符，最多32个字符
            string pattern5 = @"^.{8,32}$";

            if (!Regex.IsMatch(str, pattern5))
            {
                m_PwdError.gameObject.SetActive(true);
                m_PwdErrorStr.text = "密码小于8位数或大于32位";
                return;
            }
            m_PasswordStr = str;
            m_PwdErrorStr.text = "";
            m_PwdError.gameObject.SetActive(false);

            //if (Regex.IsMatch(str, pattern1))
            //{
            //    n++;
            //}
            //if (Regex.IsMatch(str, pattern2))
            //{
            //    n++;
            //}
            //if (Regex.IsMatch(str, pattern3))
            //{
            //    n++;
            //}
            //if (Regex.IsMatch(str, pattern4))
            //{
            //    n++;
            //}

            //if (n >= 3)
            //{
            //    m_PasswordStr = str;
            //    m_PwdErrorStr.text = "";
            //    m_PwdError.gameObject.SetActive(false);
            //}
            //else
            //{
            //    m_PwdError.gameObject.SetActive(true);
            //    m_PasswordStr = "";
            //    m_PwdErrorStr.text = "密码不正确，请重新输入";
            //}
        }

        if (!string.IsNullOrWhiteSpace(m_AccountStr) && !string.IsNullOrWhiteSpace(m_PasswordStr))
        {
            m_Logn.interactable = true;
        }
    }
    /// <summary>
    /// 清理密码输入
    /// </summary>
    private void OnClickEmptyPwd()
    {
        m_PwdErrorStr.text = "密码不能为空";
        m_PwdError.gameObject.SetActive(true);
        m_PasswordStr = "";
        m_Password.text = "";
        m_Logn.interactable = false;
    }
    /// <summary>
    /// 是否可以显示密码
    /// </summary>
    private void OnclickLockPwd()
    {
        if (m_Islock)
        {
            m_Password.contentType = SCInputField.ContentType.Password;
        }
        else
        {
            m_Password.contentType = SCInputField.ContentType.Standard;

        }
        m_Islock = !m_Islock;
    }
    /// <summary>
    /// 登录
    /// </summary>
    private void OnClickLogin()
    {

       // m_AccountStr = "Blue@163.com";

        m_AccountStr = "wentan.cai@nfznxr.com";
        m_PasswordStr = "123456Aa";

        if (string.IsNullOrWhiteSpace(m_AccountStr))
        {
            //m_AccountError.gameObject.SetActive(true);
            
            m_AccountErrorStr.text = "账号不能为空";
            return;
        }

        if (string.IsNullOrWhiteSpace(m_PasswordStr))
        {
            //m_PwdError.gameObject.SetActive(true);
            m_PwdErrorStr.text = "密码不能为空";
            return;
        }

        if (m_IsRemberPwd)
        {
            PlayerPrefs.SetString("Account", m_AccountStr);
            PlayerPrefs.SetString("Password", m_PasswordStr);
            PlayerPrefs.SetString("IsremPwd", "1");
        }
        else
        {
            PlayerPrefs.SetString("Account", "");
            PlayerPrefs.SetString("Password", "");
            PlayerPrefs.SetString("IsremPwd", "0");
        }      

        //向服务器发送账号和密码进行验证

        Debug.Log("向服务器发送账号和密码进行登录");
        SendLogin sendLogin = new SendLogin();
        sendLogin.email = m_AccountStr;
        sendLogin.password = m_PasswordStr;
        string jsonLogin = JsonMapper.ToJson(sendLogin);
        //  UIManager.Instance.ShowUI(UINameConfig.LoadingPanel, typeof(LoadingPanel), (int)ELoadState.login);
        HttpTool.Instance.PostLogin(HttpAction.login, jsonLogin, LoginCallBack);
    }

    /// <summary>
    /// 登录返回数据
    /// </summary>
    /// <param name="message"></param>
    public void LoginCallBack(string mes)
    {
        Debug.Log(mes);
        JObject obj = JObject.Parse(mes);
        if (obj["code"].ToString() != "200")
        {
            Debug.Log("登录失败");
            m_Logn.interactable = true;
            m_AccountError.gameObject.SetActive(true);
            m_AccountErrorStr.text = obj["message"].ToString();
           // UIManager.Instance.HideUI(UINameConfig.LoadingPanel);
            return;

        }
        else
        {
            Debug.Log("登录成功");
            var token = obj["data"]["token"].ToString();
          //  UIManager.Instance.ShowUI(UINameConfig.LoadingPanel, typeof(LoadingPanel), (int)ELoadState.getMaterialValue);
         //   StartCoroutine(GetAllMaterials(token));
        }
    }

    /// <summary>
    /// 是否记住密码
    /// </summary>
    /// <param name="b"></param>
    private void OnRemPwdValueChange(bool b)
    {
        m_IsRemberPwd = b;
    }

    /// <summary>
    /// 使用SN进行登录
    /// </summary>
    private void OnClickSnBtn()
    {
      //  string sn = SendSN.GetSN();
        //string sn = API_GSXR_Slam.SlamManager.plugin.SN;
    }

    #endregion


    public  void OnShow()
    {
      
        gameObject.transform.localScale = new Vector3(1, 1, 1);
        m_Logn.interactable = false;
        m_AccountStr = PlayerPrefs.GetString("Account", "");
        m_PasswordStr = PlayerPrefs.GetString("Password", "");
        int n = int.Parse(PlayerPrefs.GetString("IsremPwd", "0"));
        m_RemenberPwd.isOn = n > 0 ? true : false;
        m_IsRemberPwd = n > 0 ? true : false;

        //m_AccountStr = "test_adv@ghz-tech.com";
        //m_PasswordStr = "123456789";

        //m_AccountStr = "2463951@qq.com";
        //m_PasswordStr = "123456Aa";

        //m_AccountStr = "6555474@qq.com";
        //m_PasswordStr = "123456Aa";

        m_RemenberPwd.isOn = m_IsRemberPwd;

        if (!string.IsNullOrWhiteSpace(m_AccountStr) && !string.IsNullOrWhiteSpace(m_PasswordStr))
        {
            m_Account.text = m_AccountStr;
            m_Password.text = m_PasswordStr;
            m_Logn.interactable = true;
        }
        else
        {
            m_Account.text = "";
            m_Password.text = "";
            m_AccountStr = "";
            m_PasswordStr = "";
            m_Logn.interactable = false;
        }
    }

    private void Update()
    {
      
    }

    public  void OnHide()
    {
        gameObject.SetActive(false);
    }

    private  void OnDestroy()
    {
       
    }
}

public class SendInit
{
    public string sn { get; set; }
    public int projectId { get; set; }
}

public class SendLogin
{
    public string email { get; set; }
    public string password { get; set; }
}

public class SendMaterials
{
    public string url { get; set; }
}

public class SendSceneDetail
{
    public int id { get; set; }
}
